import type { GetFrameContextsParams, RunPartialParams, FinishRunParams, ShadowSelectParams } from './types';
import { FrameContext, AxeResults, PartialResult } from 'axe-core';
import axeCore from 'axe-core';
declare global {
    interface Window {
        axe: typeof axeCore;
        partialResults: string;
    }
}
export declare const axeGetFrameContexts: ({ context }: GetFrameContextsParams) => FrameContext[];
export declare const axeShadowSelect: ({ frameSelector }: ShadowSelectParams) => Element | null;
export declare const axeRunPartial: ({ context, options }: RunPartialParams) => Promise<PartialResult>;
export declare const axeFinishRun: ({ options }: FinishRunParams) => Promise<AxeResults>;
export declare function chunkResultString(chunk: string): void;
