import type { SerialContextObject, SerialSelectorList } from 'axe-core';
import type { AnalyzePageParams, AnalyzePageResponse } from './types';
/**
 * Get running context
 * @param Array include
 * @param Array exclude
 * @returns SerialContextObject
 */
export declare const normalizeContext: (includes: SerialSelectorList, excludes: SerialSelectorList) => SerialContextObject;
/**
 * Analyze the page.
 * @param AnalyzePageParams analyzeContext
 * @returns Promise<AnalyzePageResponse>
 */
export declare const analyzePage: ({ context, options }: AnalyzePageParams) => Promise<AnalyzePageResponse>;
